// Rgt_v
#pragma warning(disable:4996)
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define	DST_BUF_SIZE	1024

char	bin2char(unsigned char);		// 0  15  '0'  'F' ɕϊ
void	ascbufclear(char*);				// ASCII\NA[
int		len;

int		i, dgtct;
char	c[16];
char	adr[32];
char	ascbuf[128];
char	guide1[] = { "         +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\n" };
char	guide2[] = { "---------------------------------------------------------------------------\n" };
char	dststr[DST_BUF_SIZE];

int main(int argc, char *argv[])
{
	FILE	*fpr;
	int		i, ic;
	unsigned char	uc;
	long long		ll;
	int		ascofs;
	char*	fname;						// t@C
	errno_t	err;

	if (argc != 2) {
		printf("Rgt_v   \n");
		printf("Usage : %s [Fname]\n", argv[0]);
		exit (1);
	}
	fname = argv[1];					// t@C

	// t@CI[v
	err = fopen_s (&fpr, fname, "rb");
	if (err != 0) {
		printf ("t@C[hG[\n");
		printf (fname);
		printf ("\n");
		exit (1);
	}

	strcpy(ascbuf, ": ");				// d؂

	dststr[0] = 0;
	printf (guide1);					//
	printf (guide2);					// KCh
	dgtct = 0;
	c[1] = 0;
	ascofs = 0;
	// t@C[h
	ll = 0;
	while (1) {
		if ((dgtct%16) == 0) {
			sprintf(adr, "%08X ", ll);	// AhX
			strncat(dststr, adr, 10);
			ascbufclear(ascbuf);		// ASCII\NA[
		}
		// ASCIIR[hZbg
		ic = fgetc(fpr);
		if (ic == EOF) {
			break;
		}
		uc = (unsigned char)ic;
		if (0x20 <= uc && uc<= 0x7e) {
			if (uc == '%') {				// %
				ascbuf[ascofs+2] = uc;
				ascofs++;
				ascbuf[ascofs+2] = uc;
				ascofs++;
			} else {
				ascbuf[ascofs+2] = uc;
				ascofs++;
			}
		} else {
			ascbuf[ascofs+2] = '.';
			ascofs++;
		}
		c[0] = bin2char(uc/16);			// 
		strncat(dststr, c, 2);
		c[0] = bin2char(uc%16);			// 
		strncat(dststr, c, 2);
		c[0] = ' ';
		strncat(dststr, c, 2);
		dgtct++;
		if (dgtct >= 16) {
			dgtct = 0;
			strncat(dststr, ascbuf, ascofs+2);
			strncat(dststr, "\n", 2);
			printf (dststr);
			dststr[0] = 0;
			ascofs = 0;
		}
		ll++;
	}
	if ((dgtct%16) != 0) {
		for ( i = 0 ; i < ((16-(dgtct%16))*3) ; i++ ) {
			strncat(dststr, " ", 2);
		}
		strncat(dststr, ascbuf, 18+ascofs);
		strncat(dststr, "\n", 2);
		printf (dststr);
	}

	// t@CN[Y
	if (fpr != NULL) {
		fclose(fpr);
	}
	exit (0);
}

// 0  15  '0'  'F' ɕϊ
char bin2char(unsigned char uc)
{
	char	c;
	if (uc <= 9) {
		c = '0'+uc;
	} else if (10 <= uc && uc <= 15) {
		c = 'A'+(uc-10);
	} else {
		c = '-'+uc;
		printf("ERROR - bin2char()\n");
	}
	return c;
}

// ASCII\NA[
void ascbufclear(char* ascbuf)
{
	int i;
	for ( i = 0 ; i < 32 ; i++ ) {
		ascbuf[i+2] = ' ';
	}
}
